VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} CreateArrayPoint 
   Caption         =   "  "
   ClientHeight    =   3090
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   8565
   OleObjectBlob   =   "CreateArrayPoint.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "CreateArrayPoint"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private oProductDocument As ProductDocument
Private oPartDocument As PartDocument
Private rootObject As Object
Private oSelection As Selection
Private oConstraints As Constraints
Private oConstraint As Constraint
Private oHybridBodies As HybridBodies
Private oHybridBody As HybridBody
Private oSketches As Sketches
Private oSketch As Sketch
Private oLength, oPrevLength As Length
Private oFormula As Formula
Private oRelations As Relations
Private ctrlFactory2D As Factory2D
Private oPoint, oPrevPoint As Point2D
Private oRefLine, oAxisLine As Line2D
Private oGeomElements As GeometricElements
Private oGeomElement As GeometricElement
Private oReference1, oReference2, oReference3 As Reference
Private oAaxis As Axis2D
Private typeDoc As Variant
Private typeObj As Variant
Private lCancel As Boolean
Private lUpdateCheckBox As Boolean


Private Sub ArrayX_Click()
    If lUpdateCheckBox Then
        If Me.ArrayX Then
            lUpdateCheckBox = False
            Me.ArrayY = False
            
        Else
            lUpdateCheckBox = False
            Me.ArrayY = True
            
        End If
    Else
        lUpdateCheckBox = True
    End If
End Sub

Private Sub ArrayY_Click()
    If lUpdateCheckBox Then
        If Me.ArrayY Then
            lUpdateCheckBox = False
            Me.ArrayX = False
            
        Else
            lUpdateCheckBox = False
            Me.ArrayX = True
            
        End If
    Else
        lUpdateCheckBox = True
    End If
End Sub

Private Sub CommandButtonCreate_Click()
    SetPoint
    Unload CreateArrayPoint
End Sub

Private Sub HybridBodies_Change()
    If Me.HybridBodies.Value = "" Then
        Me.HybridBodies.Value = ""
    End If
End Sub

Private Sub HybridBodiesNew_Click()
    If Me.HybridBodiesNew Then
        Me.HybridBodies.Enabled = False
    Else
        Me.HybridBodies.Enabled = True
    End If
End Sub

Private Sub Sketches_Change()
    If Me.Sketches.Value = "" Then
        Me.Sketches.Value = " "
    End If
End Sub

Private Sub SketchesNew_Click()
    If Me.SketchesNew Then
        Me.Sketches.Enabled = False
    Else
        Me.Sketches.Enabled = True
    End If
End Sub

Private Sub UserForm_Activate()
    If lCancel Then
        Unload CreateArrayPoint
    End If
End Sub

Private Sub UserForm_Initialize()
Dim oElement

    lCancel = True
    If NecessaryDocument Then
        lUpdateCheckBox = True
        Me.ArrayX = False
        Me.ArrayY = True
        Me.TotalPoint = 20
        Me.dStep = 1.27
        Me.HybridBodies.Value = ""
        Me.Sketches.Value = " "
        Set rootObject = oPartDocument.Part
        Set oHybridBodies = rootObject.HybridBodies
        If oHybridBodies.Count > 0 Then
            For Each oElement In oHybridBodies
                Me.HybridBodies.AddItem oElement.Name
            Next
        End If
        Me.HybridBodiesNew.Value = True
        Me.HybridBodies.Enabled = False
        Me.SketchesNew.Value = True
        Me.Sketches.Enabled = False
        
    
        lCancel = False
    End If
End Sub

Function SetPoint()
Dim i, nCntConstraints, nRelationsCount, cFormulaName, cTmpFormula, cSketchName, cTmpSketchName, cHybridBodyName, cTmpHybridBodyName, nReportName As Variant
Dim sketchName As Variant
Dim cControlConstraintName As Variant
Dim oOriginElements, oPlane
Dim ndStep, ndCurX, ndCurY As Double
Dim nPointCount, oElement, nTotalPoint, lAxisX, lAxisY


ndStep = CDbl(Me.dStep)
nTotalPoint = CInt(Me.TotalPoint)
lAxisX = Me.ArrayX
lAxisY = Me.ArrayY
ndCurX = 0
ndCurY = 0
cSketchName = " "
cHybridBodyName = ""
cControlConstraintName = " ."
cFormulaName = "."

On Error GoTo EndOfConstraints

Set oPartDocument = CATIA.ActiveDocument
Set rootObject = oPartDocument.Part
Set oHybridBodies = rootObject.HybridBodies
' Check and set the cHybridBodyName element
If oHybridBodies.Count > 0 Then
    Set oHybridBody = oHybridBodies.GetItem((cHybridBodyName))
End If
' Create if not exist
If TypeName(oHybridBody) = "Nothing" Then
    Set oHybridBody = oHybridBodies.Add()
    oHybridBody.Name = cHybridBodyName
    rootObject.Update
Else
    If Me.HybridBodiesNew Then
        For i = 1 To oHybridBodies.Count
            cTmpHybridBodyName = cHybridBodyName & "_" & LTrim(RTrim(Str(i)))
            Set oHybridBody = oHybridBodies.GetItem((cTmpHybridBodyName))
            If TypeName(oHybridBody) = "Nothing" Then
               Set oHybridBody = oHybridBodies.Add()
                oHybridBody.Name = cTmpHybridBodyName
                rootObject.Update
                Exit For
            End If
        Next
    Else
        cHybridBodyName = Me.HybridBodies
        Set oHybridBody = oHybridBodies.GetItem((cHybridBodyName))
    End If
End If
Set oOriginElements = rootObject.OriginElements
Set oPlane = oOriginElements.PlaneXY
Set oSketches = oHybridBody.HybridSketches
' Check and set the cSketchName element
If oSketches.Count > 0 Then
    Set oSketch = oSketches.GetItem((cSketchName))
End If
' Create if not exist
If TypeName(oSketch) = "Nothing" Then
    Set oSketch = oSketches.Add(oPlane)
    oSketch.Name = cSketchName
    rootObject.Update
Else
    If Me.SketchesNew Then
        For i = 1 To oHybridBody.HybridSketches.Count
            cTmpSketchName = cSketchName & "_" & LTrim(RTrim(Str(i)))
            Set oSketch = oHybridBody.HybridSketches.GetItem((cTmpSketchName))
            If TypeName(oSketch) = "Nothing" Then
                Set oSketch = oHybridBody.HybridSketches.Add(oPlane)
                oSketch.Name = cTmpSketchName
                rootObject.Update
                Exit For
            End If
        Next
    End If
End If
'
Set oConstraints = oSketch.Constraints
nCntConstraints = ItemMaxNumber(oConstraints, cControlConstraintName)
Set oRelations = rootObject.Relations
nRelationsCount = ItemMaxNumber(oRelations, cFormulaName)
' Get max number of ReportName point
nReportName = 0
Set oGeomElements = oSketch.GeometricElements
For Each oElement In oGeomElements
    If oElement.GeometricType = catGeoTypePoint2D Then
        If oElement.ReportName > nReportName Then
           nReportName = oElement.ReportName
        End If
    End If
Next
' Open sketch editor
Set ctrlFactory2D = oSketch.OpenEdition
' Create reference line
If lAxisY Then
    Set oRefLine = ctrlFactory2D.CreateLine(ndCurX, ndCurY, ndCurX, ndStep * (nTotalPoint - 1))
    'oSketch.HorizontalReference
    Set oAxis = oGeomElements.Item(" ")
    Set oAxisLine = oAxis.GetItem("-")
    Set oReference1 = rootObject.CreateReferenceFromObject(oRefLine)
    Set oReference2 = rootObject.CreateReferenceFromObject(oAxisLine)
    Set oConstraint = oConstraints.AddBiEltCst(catCstTypeVerticality, oReference1, oReference2)
    oConstraint.Mode = catCstModeDrivingDimension
End If
If lAxisX Then
    Set oRefLine = ctrlFactory2D.CreateLine(ndCurX, ndCurY, ndStep * (nTotalPoint - 1), ndCurY)
    Set oAxis = oGeomElements.Item(" ")
    Set oAxisLine = oAxis.GetItem("-")
    Set oReference1 = rootObject.CreateReferenceFromObject(oRefLine)
    Set oReference2 = rootObject.CreateReferenceFromObject(oAxisLine)
    Set oConstraint = oConstraints.AddBiEltCst(catCstTypeHorizontality, oReference1, oReference2)
    oConstraint.Mode = catCstModeDrivingDimension
End If
oRefLine.Construction = True

i = 0
Do While i < nTotalPoint
    i = i + 1
    ' Create point
    Set oPoint = ctrlFactory2D.CreatePoint(ndCurX, ndCurY)
    oPoint.ReportName = nReportName + 1
    oPoint.Construction = False
    If lAxisX Then
        ndCurX = ndCurX + ndStep
    End If
    If lAxisY Then
        ndCurY = ndCurY + ndStep
    End If
    If TypeName(oPrevPoint) = "Nothing" Then
        Set oPrevPoint = oPoint
        Set oReference1 = rootObject.CreateReferenceFromObject(oPrevPoint)
        Set oReference3 = rootObject.CreateReferenceFromObject(oRefLine)
        Set oConstraint = oConstraints.AddBiEltCst(catCstTypeOn, oReference1, oReference3)
        oConstraint.Mode = catCstModeDrivingDimension
    Else
        Set oReference1 = rootObject.CreateReferenceFromObject(oPrevPoint)
        Set oReference2 = rootObject.CreateReferenceFromObject(oPoint)
        Set oReference3 = rootObject.CreateReferenceFromObject(oRefLine)
        Set oConstraint = oConstraints.AddBiEltCst(catCstTypeOn, oReference1, oReference3)
        oConstraint.Mode = catCstModeDrivingDimension
        Set oConstraint = oConstraints.AddBiEltCst(catCstTypeDistance, oReference1, oReference2)
        oConstraint.Mode = catCstModeDrivingDimension
        Set oLength = oConstraint.Dimension
        oLength.Value = ndStep
        Set oPrevPoint = oPoint
        ' If last point in array
        If i = nTotalPoint Then
            Set oConstraint = oConstraints.AddBiEltCst(catCstTypeOn, oReference2, oReference3)
            oConstraint.Mode = catCstModeDrivingDimension
        End If
    End If
Loop
' Link to base dimension
Set oConstraints = oSketch.Constraints
i = 0
For Each oConstraint In oConstraints
    If oConstraint.Type = catCstTypeDistance Then
        i = i + 1
        If i = 1 Then
            cControlConstraintName = oConstraint.Name
        Else
            cTmpFormula = cFormulaName & RTrim(LTrim(Str(nRelationsCount + 1)))
            Set oLength = oConstraint.Dimension
            Set oFormula = oRelations.CreateFormula((cTmpFormula), "", oLength, "`" & oHybridBody.Name & "\" & oSketch.Name & "\" & cControlConstraintName & "\Offset`")
        End If
    End If
Next
' Close sketch editor
oSketch.CloseEdition
rootObject.Update

EndOfConstraints:

End Function

Function StrInStr(cStr1 As Variant, cStr2 As Variant) As Boolean
    StrInStr = False
    If InStr(1, UCase(cStr2), UCase(cStr1), vbTextCompare) <> 0 Then
        StrInStr = True
    End If
End Function
Function ItemMaxNumber(obj, cKey)
Dim nStep As Long
Dim nPos, cNum, nNum, nMaxNum As Variant
    ItemCount = 0
    nMaxNum = 0
    For nStep = 1 To obj.Count
        If InStr(1, obj.Item(nStep).Name, cKey) <> 0 Then
            nPos = InStr(1, obj.Item(nStep).Name, ".")
            cNum = Mid(obj.Item(nStep).Name, nPos + 1)
            nNum = Val(cNum)
            If nNum > nMaxNum Then
                nMaxNum = nNum
            End If
        End If
    Next
    ItemMaxNumber = nMaxNum
End Function

Function NecessaryDocument()
Dim typeDoc As Variant

    NecessaryDocument = False
    On Error GoTo SkipCode
    typeDoc = TypeName(CATIA.ActiveDocument)
    Select Case typeDoc
        Case "ProductDocument"
            Set oProductDocument = CATIA.ActiveDocument
            Set oSelection = oProductDocument.Selection
            Set rootObject = oProductDocument.Product
            NecessaryDocument = True
            
        Case "PartDocument"
            Set oPartDocument = CATIA.ActiveDocument
            Set oSelection = oPartDocument.Selection
            Set rootObject = oPartDocument.Product
            NecessaryDocument = True
        
    End Select

SkipCode:

    On Error GoTo 0
    
End Function
